Subject: Re: [RFC PATCH] ASoC: Intel: avs: Fix reading 1 or more bytes from a region of size 0

From: Takashi Iwai <[email-masked]>
Date: Thu, 04 Sep 2025 11:14:21 +0200

On Thu, 04 Sep 2025 10:40:58 +0200,
Brahmajit Das wrote:
> 
> On 02.09.2025 10:15, Takashi Iwai wrote:
> > On Tue, 02 Sep 2025 10:08:12 +0200,
> > Brahmajit Das wrote:
> > > 
> > > Building the next tree with GCC 16, results in the following error:
> > > 
> > > sound/soc/intel/avs/path.c:137:38: error: ‘strcmp’ reading 1 or more bytes from a region of size 0 [-Werror=stringop-overread]
> > >   137 |         return id->id == id2->id && !strcmp(id->tplg_name, id2->tplg_name);
> > >       |                                      ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
> ...snip...
> > > Signed-off-by: Brahmajit Das <[email-masked]>
> > > ---
> > >  sound/soc/intel/avs/path.c | 3 ++-
> > >  1 file changed, 2 insertions(+), 1 deletion(-)
> > > 
> > > diff --git a/sound/soc/intel/avs/path.c b/sound/soc/intel/avs/path.c
> > > index 7aa20fcf1a33..8c3df2002b58 100644
> > > --- a/sound/soc/intel/avs/path.c
> > > +++ b/sound/soc/intel/avs/path.c
> > > @@ -134,7 +134,8 @@ static struct avs_tplg_path *avs_condpath_find_variant(struct avs_dev *adev,
> > >  static bool avs_tplg_path_template_id_equal(struct avs_tplg_path_template_id *id,
> > >  					    struct avs_tplg_path_template_id *id2)
> > >  {
> > > -	return id->id == id2->id && !strcmp(id->tplg_name, id2->tplg_name);
> > > +	return id->id == id2->id &&
> > > +	       !strncmp(id->tplg_name, id2->tplg_name, strlen(id->tplg_name));
> > 
> > Please use sizeof()-1 instead of strlen(), as it's a fixed size array.
> > 
> > Practically seen, it's likely a false-positive from the new compiler.
> > But it's still safer to add the boundary check in the code itself.
> > 
> > 
> > thanks,
> > 
> > Takashi
> So, I was testing again and with sizeof, I'm getting
> 
> sound/soc/intel/avs/path.c:137:38: error: ‘strncmp’ specified bound 43 exceeds source size 0 [-Werror=stringop-overread]
>   137 |         return id->id == id2->id && !strncmp(id->tplg_name, id2->tplg_name,
>       |                                      ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
>   138 |                                              sizeof(id->tplg_name) - 1);
>       |                                              ~~~~~~~~~~~~~~~~~~~~~~~~~~
> 
> So my previous v2 is wrong, please ignore that.
> Whereas, with strlen there's no warning :( . I'm quite confused, and
> lack the GCC knowledge.

It smells more like a compiler problem.
Care to report to gcc people before scratching too much here?

thanks,

Takashi